﻿// ConvertInfo : FairlyWrites 7.4.6.2 - 2016/05/10 11:28:33
{
  var objTOC = new TocObject();
  objTOC.setTitle("3DS プログラミングマニュアル<br /> - NFP ライブラリ編");
  objTOC.setWindowTitle("3DS プログラミングマニュアル - NFP ライブラリ編");
  objTOC.disablePrintPage();
  objTOC.setInsertTitlePage(true);
  objTOC.disableDisplayNumber();
  objTOC.disableViewFileIcon();
  objTOC.setBaselevel(0);
  objTOC.setSearchEnabled(true);
  objTOC.setLogoFile("template/img/logo.png");

// 1. はじめに
  objTOC.addHeader("ID_57056789", 0, "1. はじめに", "Pages/Page_57056789.html", "");

// 2. NFP ライブラリでできること
  objTOC.addHeader("ID_57056846", 0, "2. NFP ライブラリでできること", "Pages/Page_57056846.html", "");

// 3. 共用領域とアプリ専用領域
  objTOC.addHeader("ID_57057258", 0, "3. 共用領域とアプリ専用領域", "Pages/Page_57057258.html", "");

// 4. ステート遷移
  objTOC.addHeader("ID_57056953", 0, "4. ステート遷移", "Pages/Page_57056953.html", "");

// 5. 処理フロー
  objTOC.addHeader("ID_57057209", 0, "5. 処理フロー", "Pages/Page_57057209.html", "");

// 5.1. 初期化シーケンス
  objTOC.addItem("ID_57057209", 1, "5.1. 初期化シーケンス", "Pages/Page_57057209.html", "PageId_57063979");

// 5.2. 終了シーケンス
  objTOC.addItem("ID_57057209", 1, "5.2. 終了シーケンス", "Pages/Page_57057209.html", "PageId_57064000");

// 5.3. 共通エラーハンドリング
  objTOC.addItem("ID_57057209", 1, "5.3. 共通エラーハンドリング", "Pages/Page_57057209.html", "PageId_57064210");

// 5.4. タグチェックシーケンス
  objTOC.addItem("ID_57057209", 1, "5.4. タグチェックシーケンス", "Pages/Page_57057209.html", "PageId_59481027");

// 5.5. タグ検知開始シーケンス
  objTOC.addItem("ID_57057209", 1, "5.5. タグ検知開始シーケンス", "Pages/Page_57057209.html", "PageId_57064079");

// 5.6. タグ喪失通知待ち受けシーケンス
  objTOC.addItem("ID_57057209", 1, "5.6. タグ喪失通知待ち受けシーケンス", "Pages/Page_57057209.html", "PageId_57064280");

// 5.7. タグマウントシーケンス
  objTOC.addItem("ID_57057209", 1, "5.7. タグマウントシーケンス", "Pages/Page_57057209.html", "PageId_57064311");

// 5.8. タグ復旧シーケンス
  objTOC.addItem("ID_57057209", 1, "5.8. タグ復旧シーケンス", "Pages/Page_57057209.html", "PageId_58757070");

// 5.9. 「amiibo設定」起動シーケンス
  objTOC.addItem("ID_57057209", 1, "5.9. 「amiibo設定」起動シーケンス", "Pages/Page_57057209.html", "PageId_58757087");

// 5.10. NFP タグへのアクセスを行う処理フロー
  objTOC.addItem("ID_57057209", 1, "5.10. NFP タグへのアクセスを行う処理フロー", "Pages/Page_57057209.html", "PageId_58000619");

// 5.10.1. 共用情報取得シーケンス
  objTOC.addItem("ID_57057209", 2, "5.10.1. 共用情報取得シーケンス", "Pages/Page_57057209.html", "PageId_57064566");

// 5.10.2. 登録情報取得シーケンス
  objTOC.addItem("ID_57057209", 2, "5.10.2. 登録情報取得シーケンス", "Pages/Page_57057209.html", "PageId_57064937");

// 5.10.3. アプリ専用領域アクセス開始シーケンス
  objTOC.addItem("ID_57057209", 2, "5.10.3. アプリ専用領域アクセス開始シーケンス", "Pages/Page_57057209.html", "PageId_57070656");

// 5.10.4. アプリ専用領域作成シーケンス
  objTOC.addItem("ID_57057209", 2, "5.10.4. アプリ専用領域作成シーケンス", "Pages/Page_57057209.html", "PageId_57070836");

// 5.10.5. アプリ専用領域チェックシーケンス
  objTOC.addItem("ID_57057209", 2, "5.10.5. アプリ専用領域チェックシーケンス", "Pages/Page_57057209.html", "PageId_57071476");

// 5.10.6. アプリ専用領域読み込みシーケンス
  objTOC.addItem("ID_57057209", 2, "5.10.6. アプリ専用領域読み込みシーケンス", "Pages/Page_57057209.html", "PageId_57070844");

// 5.10.7. アプリ専用領域書き込みシーケンス
  objTOC.addItem("ID_57057209", 2, "5.10.7. アプリ専用領域書き込みシーケンス", "Pages/Page_57057209.html", "PageId_58000608");

// 5.11. 3DS のアプリケーションで必要となる処理
  objTOC.addItem("ID_57057209", 1, "5.11. 3DS のアプリケーションで必要となる処理", "Pages/Page_57057209.html", "PageId_58758081");

// 5.11.1. HOMEメニュー遷移シーケンス
  objTOC.addItem("ID_57057209", 2, "5.11.1. HOMEメニュー遷移シーケンス", "Pages/Page_57057209.html", "PageId_58758108");

// 5.11.2. スリープ遷移シーケンス
  objTOC.addItem("ID_57057209", 2, "5.11.2. スリープ遷移シーケンス", "Pages/Page_57057209.html", "PageId_58758174");

// 5.11.3. 電源断シーケンス
  objTOC.addItem("ID_57057209", 2, "5.11.3. 電源断シーケンス", "Pages/Page_57057209.html", "PageId_58758244");

// 5.11.4. NFC リーダー/ライター接続シーケンス
  objTOC.addItem("ID_57057209", 2, "5.11.4. NFC リーダー/ライター接続シーケンス", "Pages/Page_57057209.html", "PageId_70413674");

// 6. NFP ライブラリの利用方法
  objTOC.addHeader("ID_57057101", 0, "6. NFP ライブラリの利用方法", "Pages/Page_57057101.html", "");

// 6.1. 初期化
  objTOC.addItem("ID_57057101", 1, "6.1. 初期化", "Pages/Page_57057101.html", "PageId_57057098");

// 6.1.1. タグ検知に関する通知を受け取るイベントの設定
  objTOC.addItem("ID_57057101", 2, "6.1.1. タグ検知に関する通知を受け取るイベントの設定", "Pages/Page_57057101.html", "PageId_57063254");

// 6.1.1.1. タグ発見通知に対する処理
  objTOC.addItem("ID_57057101", 3, "6.1.1.1. タグ発見通知に対する処理", "Pages/Page_57057101.html", "PageId_57058634");

// 6.1.1.2. タグ喪失通知に対する処理
  objTOC.addItem("ID_57057101", 3, "6.1.1.2. タグ喪失通知に対する処理", "Pages/Page_57057101.html", "PageId_57060044");

// 6.2. タグ検知の開始
  objTOC.addItem("ID_57057101", 1, "6.2. タグ検知の開始", "Pages/Page_57057101.html", "PageId_57058357");

// 6.3. タグ情報の取得
  objTOC.addItem("ID_57057101", 1, "6.3. タグ情報の取得", "Pages/Page_57057101.html", "PageId_57060280");

// 6.4. タグのマウント
  objTOC.addItem("ID_57057101", 1, "6.4. タグのマウント", "Pages/Page_57057101.html", "PageId_57059984");

// 6.4.1. タグの復旧
  objTOC.addItem("ID_57057101", 2, "6.4.1. タグの復旧", "Pages/Page_57057101.html", "PageId_57903506");

// 6.5. 「amiibo設定」の起動
  objTOC.addItem("ID_57057101", 1, "6.5. 「amiibo設定」の起動", "Pages/Page_57057101.html", "PageId_57903933");

// 6.6. NFP タグへのアクセス
  objTOC.addItem("ID_57057101", 1, "6.6. NFP タグへのアクセス", "Pages/Page_57057101.html", "PageId_57059941");

// 6.6.1. 共用領域へのアクセス
  objTOC.addItem("ID_57057101", 2, "6.6.1. 共用領域へのアクセス", "Pages/Page_57057101.html", "PageId_57060268");

// 6.6.2. アプリ専用領域へのアクセス
  objTOC.addItem("ID_57057101", 2, "6.6.2. アプリ専用領域へのアクセス", "Pages/Page_57057101.html", "PageId_57073665");

// 6.6.2.1. アプリ専用領域の作成
  objTOC.addItem("ID_57057101", 3, "6.6.2.1. アプリ専用領域の作成", "Pages/Page_57057101.html", "PageId_57073787");

// 6.6.2.2. アプリ専用領域の読み込み
  objTOC.addItem("ID_57057101", 3, "6.6.2.2. アプリ専用領域の読み込み", "Pages/Page_57057101.html", "PageId_57903228");

// 6.6.2.3. アプリ専用領域への書き込み
  objTOC.addItem("ID_57057101", 3, "6.6.2.3. アプリ専用領域への書き込み", "Pages/Page_57057101.html", "PageId_57903422");

// 6.7. タグのマウント解除
  objTOC.addItem("ID_57057101", 1, "6.7. タグのマウント解除", "Pages/Page_57057101.html", "PageId_57063423");

// 6.8. タグ検知の終了
  objTOC.addItem("ID_57057101", 1, "6.8. タグ検知の終了", "Pages/Page_57057101.html", "PageId_57063418");

// 6.9. 終了
  objTOC.addItem("ID_57057101", 1, "6.9. 終了", "Pages/Page_57057101.html", "PageId_57063795");

// 6.10. 3DS のアプリケーションで利用する場合
  objTOC.addItem("ID_57057101", 1, "6.10. 3DS のアプリケーションで利用する場合", "Pages/Page_57057101.html", "PageId_58756511");

// 6.10.1. HOMEボタンへの対処
  objTOC.addItem("ID_57057101", 2, "6.10.1. HOMEボタンへの対処", "Pages/Page_57057101.html", "PageId_58000769");

// 6.10.2. スリープ要求への対処
  objTOC.addItem("ID_57057101", 2, "6.10.2. スリープ要求への対処", "Pages/Page_57057101.html", "PageId_58753455");

// 6.10.3. 電源ボタンへの対処
  objTOC.addItem("ID_57057101", 2, "6.10.3. 電源ボタンへの対処", "Pages/Page_57057101.html", "PageId_58753544");

// 6.10.4. CTR 対応に必要な実装
  objTOC.addItem("ID_57057101", 2, "6.10.4. CTR 対応に必要な実装", "Pages/Page_57057101.html", "PageId_58757472");

// 6.10.5. システムに負荷がかかっている場合の NFP ライブラリの動作
  objTOC.addItem("ID_57057101", 2, "6.10.5. システムに負荷がかかっている場合の NFP ライブラリの動作", "Pages/Page_57057101.html", "PageId_82029170");

  objTOC.addGuidelineSection("HISTORY", 0, "更新履歴", "history.html", "");

  objTOC.processTreeData();
  Reassemble.objectTocData = objTOC;
}
