﻿// ConvertInfo : FairlyWrites 7.4.6.2 - 2016/05/10 11:28:19
{
  var objTOC = new TocObject();
  objTOC.setTitle("3DS プログラミングマニュアル<br /> - FONT ライブラリ編");
  objTOC.setWindowTitle("3DS プログラミングマニュアル - FONT ライブラリ編");
  objTOC.disablePrintPage();
  objTOC.setInsertTitlePage(true);
  objTOC.disableDisplayNumber();
  objTOC.disableViewFileIcon();
  objTOC.setBaselevel(0);
  objTOC.setSearchEnabled(true);
  objTOC.setLogoFile("template/img/logo.png");

// 1. はじめに
  objTOC.addHeader("ID_53970596", 0, "1. はじめに", "Pages/Page_53970596.html", "");

// 2. 用語
  objTOC.addHeader("ID_53970597", 0, "2. 用語", "Pages/Page_53970597.html", "");

// 2.1. 文字に関連する用語
  objTOC.addItem("ID_53970597", 1, "2.1. 文字に関連する用語", "Pages/Page_53970597.html", "PageId_53970598");

// 2.2. グリフに関連する用語
  objTOC.addItem("ID_53970597", 1, "2.2. グリフに関連する用語", "Pages/Page_53970597.html", "PageId_53970599");

// 2.3. フォントのリソースに関する用語
  objTOC.addItem("ID_53970597", 1, "2.3. フォントのリソースに関する用語", "Pages/Page_53970597.html", "PageId_53970600");

// 2.3.1. グリフグループ
  objTOC.addItem("ID_53970597", 2, "2.3.1. グリフグループ", "Pages/Page_53970597.html", "PageId_53970601");

// 2.3.2. シート
  objTOC.addItem("ID_53970597", 2, "2.3.2. シート", "Pages/Page_53970597.html", "PageId_53970602");

// 2.4. その他の用語
  objTOC.addItem("ID_53970597", 1, "2.4. その他の用語", "Pages/Page_53970597.html", "PageId_53970603");

// 3. フォントの管理
  objTOC.addHeader("ID_53970604", 0, "3. フォントの管理", "Pages/Page_53970604.html", "");

// 3.1. Font クラス
  objTOC.addItem("ID_53970604", 1, "3.1. Font クラス", "Pages/Page_53970604.html", "PageId_53970605");

// 3.2. ResFont クラス
  objTOC.addItem("ID_53970604", 1, "3.2. ResFont クラス", "Pages/Page_53970604.html", "PageId_53970606");

// 3.2.1. 内蔵フォント
  objTOC.addItem("ID_53970604", 2, "3.2.1. 内蔵フォント", "Pages/Page_53970604.html", "PageId_53970607");

// 3.3. ArchiveFont クラス
  objTOC.addItem("ID_53970604", 1, "3.3. ArchiveFont クラス", "Pages/Page_53970604.html", "PageId_53970608");

// 3.4. PackedFont クラス
  objTOC.addItem("ID_53970604", 1, "3.4. PackedFont クラス", "Pages/Page_53970604.html", "PageId_53970609");

// 3.5. PairFont クラス
  objTOC.addItem("ID_53970604", 1, "3.5. PairFont クラス", "Pages/Page_53970604.html", "PageId_53970610");

// 4. 文字の表示
  objTOC.addHeader("ID_53970611", 0, "4. 文字の表示", "Pages/Page_53970611.html", "");

// 4.1. グリフの情報をもとに表示する
  objTOC.addItem("ID_53970611", 1, "4.1. グリフの情報をもとに表示する", "Pages/Page_53970611.html", "PageId_53970612");

// 4.2. FONT ライブラリのクラスを利用する
  objTOC.addItem("ID_53970611", 1, "4.2. FONT ライブラリのクラスを利用する", "Pages/Page_53970611.html", "PageId_53970613");

// 4.2.1. アプリケーションでの実装手順
  objTOC.addItem("ID_53970611", 2, "4.2.1. アプリケーションでの実装手順", "Pages/Page_53970611.html", "PageId_53970614");

// 4.2.1.1. フォントリソースのロードと構築
  objTOC.addItem("ID_53970611", 3, "4.2.1.1. フォントリソースのロードと構築", "Pages/Page_53970611.html", "PageId_53970615");

// 4.2.1.2. シェーダの初期化
  objTOC.addItem("ID_53970611", 3, "4.2.1.2. シェーダの初期化", "Pages/Page_53970611.html", "PageId_53970616");

// 4.2.1.3. 表示文字列用バッファの確保
  objTOC.addItem("ID_53970611", 3, "4.2.1.3. 表示文字列用バッファの確保", "Pages/Page_53970611.html", "PageId_53970617");

// 4.2.1.4. 描画設定
  objTOC.addItem("ID_53970611", 3, "4.2.1.4. 描画設定", "Pages/Page_53970611.html", "PageId_53970618");

// 4.2.1.5. 描画ごとに行う処理
  objTOC.addItem("ID_53970611", 3, "4.2.1.5. 描画ごとに行う処理", "Pages/Page_53970611.html", "PageId_53970619");

// 4.2.1.6. ライブラリによる GPU 設定の変化
  objTOC.addItem("ID_53970611", 3, "4.2.1.6. ライブラリによる GPU 設定の変化", "Pages/Page_53970611.html", "PageId_53970620");

// 4.2.2. タグ文字の処理をカスタマイズする
  objTOC.addItem("ID_53970611", 2, "4.2.2. タグ文字の処理をカスタマイズする", "Pages/Page_53970611.html", "PageId_53970621");

// 5. フォントの作成
  objTOC.addHeader("ID_53970622", 0, "5. フォントの作成", "Pages/Page_53970622.html", "");

// 5.1. 作成に利用するファイル
  objTOC.addItem("ID_53970622", 1, "5.1. 作成に利用するファイル", "Pages/Page_53970622.html", "PageId_53970623");

// 5.1.1. 共通する構造
  objTOC.addItem("ID_53970622", 2, "5.1.1. 共通する構造", "Pages/Page_53970622.html", "PageId_53970624");

// 5.1.2. 文字フィルタファイル
  objTOC.addItem("ID_53970622", 2, "5.1.2. 文字フィルタファイル", "Pages/Page_53970622.html", "PageId_53970625");

// 5.1.3. グリフグループファイル
  objTOC.addItem("ID_53970622", 2, "5.1.3. グリフグループファイル", "Pages/Page_53970622.html", "PageId_53970626");

// 5.1.4. 文字順序ファイル
  objTOC.addItem("ID_53970622", 2, "5.1.4. 文字順序ファイル", "Pages/Page_53970622.html", "PageId_53970627");

// 5.1.4.1. 記述上の注意
  objTOC.addItem("ID_53970622", 3, "5.1.4.1. 記述上の注意", "Pages/Page_53970622.html", "PageId_53970628");

// 5.2. PC にインストールされているフォントから作成する
  objTOC.addItem("ID_53970622", 1, "5.2. PC にインストールされているフォントから作成する", "Pages/Page_53970622.html", "PageId_53970629");

// 5.3. 画像データから作成する
  objTOC.addItem("ID_53970622", 1, "5.3. 画像データから作成する", "Pages/Page_53970622.html", "PageId_53970630");

// 5.3.1. ブロック
  objTOC.addItem("ID_53970622", 2, "5.3.1. ブロック", "Pages/Page_53970622.html", "PageId_53970632");

// 5.3.2. セルと幅線領域
  objTOC.addItem("ID_53970622", 2, "5.3.2. セルと幅線領域", "Pages/Page_53970622.html", "PageId_53970633");

// 5.3.2.1. 配置情報
  objTOC.addItem("ID_53970622", 3, "5.3.2.1. 配置情報", "Pages/Page_53970622.html", "PageId_53970634");

// 5.4. 既存のフォントリソースから作成する
  objTOC.addItem("ID_53970622", 1, "5.4. 既存のフォントリソースから作成する", "Pages/Page_53970622.html", "PageId_53970635");

  objTOC.addGuidelineSection("HISTORY", 0, "更新履歴", "history.html", "");

  objTOC.processTreeData();
  Reassemble.objectTocData = objTOC;
}
